FUNCTION HSL2RGB

PARAMETERS pHue, pSat, pLum, pRed, pGrn, pBlu

   pHue = pHue / 255
   pSat = pSat / 255
   pLum = pLum / 255

   If pSat = 0 Then
      pRed = pLum
      pGrn = pLum
      pBlu = pLum
   Else

      If pLum < 0.5 Then
         temp2 = pLum * (1 + pSat)
      Else
         temp2 = pLum + pSat - pLum * pSat
      EndIf

      temp1 = 2 * pLum - temp2
   
   		DIME temp3(3)

      temp3(1) = pHue + 1 / 3
      temp3(2) = pHue
      temp3(3) = pHue - 1 / 3
      
      LOCAL n
      For n = 1 To 3
         If temp3(n) < 0
         	temp3(n) = temp3(n) + 1
         ENDIF
         If temp3(n) > 1
         	temp3(n) = temp3(n) - 1
      	 ENDIF
      	 
         If 6 * temp3(n) < 1 Then
            temp3(n) = temp1 + (temp2 - temp1) * 6 * temp3(n)
         Else
            If 2 * temp3(n) < 1 Then
               temp3(n) = temp2
            Else
               If 3 * temp3(n) < 2 Then
                  temp3(n) = temp1 + (temp2 - temp1) * ((2 / 3) - temp3(n)) * 6
               Else
                  temp3(n) = temp1
                EndIf
             EndIf
          EndIf
       ENDFOR

       pRed = temp3(1)
       pGrn = temp3(2)
       pBlu = temp3(3)
    EndIf

    pRed = Int(pRed * 255)
    pGrn = Int(pGrn * 255)
    pBlu = Int(pBlu * 255)
    
RETURN 
