LPARAMETERS nRGB, RetVal

*- nRGB is a single decimal number for a color as returned 
*- by properties like BackColor

*- RetVal is an array passed by reference

*- First convert it to its RGB components

LOCAL cRGB
cRGB = RIGHT(TRANS(nRGB, "@0"),6)

LOCAL nRed, nGrn, nBlu
nRed = EVAL("0x"+RIGHT(cRGB,2))
nGrn = EVAL("0x"+SUBS(cRGB,3,2))
nBlu = EVAL("0x"+LEFT(cRGB,2))

LOCAL pRed , pGreen, pBlue
LOCAL RetVal
LOCAL pMax, pMin
LOCAL pLum, pSat, pHue
    
pRed = nRed / 255
pGreen = nGrn / 255
pBlue = nBlu / 255

DO CASE
	CASE pRed > pGreen
		pMax = IIF(pRed > pBlue, pRed, pBlue)	
	CASE pGreen > pBlue
		pMax = pGreen
	OTHERWISE
		pMax = pBlue
ENDCASE
   
DO CASE
	CASE pRed < pGreen
		pMin = IIF(pRed < pBlue, pRed, pBlue)	
	CASE pGreen < pBlue
		pMin = pGreen	
	OTHERWISE
		pMin = pBlue
ENDCASE

pLum = (pMax + pMin) / 2
   
IF pMax = pMin
		pSat = 0
		pHue = 0
ELSE

	IF pLum < 0.5
		pSat = (pMax - pMin) / (pMax + pMin)	
	ELSE
		pSat = (pMax - pMin) / (2 - pMax - pMin)
	ENDIF
	
	DO CASE
		CASE pMax = pRed
			pHue = (pGreen - pBlue) / (pMax - pMin)
		CASE pMax = pGreen
			pHue = 2 + (pBlue - pRed) / (pMax - pMin)
		CASE pMax = pBlue
			pHue = 4 + (pRed - pGreen) / (pMax - pMin)
	ENDCASE
        
ENDIF

DIME RetVal(3)

RetVal(1) = pHue * 255 / 6
IF RetVal(1) < 0
	RetVal(1) = RetVal(1) + 255
ENDIF
RetVal(2) = INT(pSat * 255)
RetVal(3) = INT(pLum * 255)

RETURN RetVal
